//
//  HCGoogleCastTool.h
//  HCVideoPlayer
//
//  Created by chc on 2018/6/7.
//  Copyright © 2018年 chc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <GoogleCast/Googlecast.h>

@interface HCGoogleCastTool : NSObject

/**
 设置投屏applicationID、日志代理

 @param applicationID 投屏的应用ID
 @param delegate 日志代理
 */
+ (void)configApplicationID:(NSString *)applicationID delegate:(id <GCKLoggerDelegate>)delegate;


/**
 初始化投屏（需先调用+setupApplicationID:delegate:方法）
 */
+ (void)initCast;

+ (GCKUIMediaController *)castMediaController;
+ (BOOL)isCastingWithUrl:(NSString *)url;
+ (void)clearCastUrl;

/**
 添加投票监听者

 @param listener 监听者
 */
+ (void)addSessionManagerListener:(id <GCKSessionManagerListener>)listener;

+ (void)startRemotePlaybackWithStreamType:(GCKMediaStreamType)streamType title:(NSString *)title description:(NSString *)description studio:(NSString *)studio photo:(NSString *)photo urlStr:(NSString *)urlStr;

+ (void)playRemotelyWithStreamType:(GCKMediaStreamType)streamType title:(NSString *)title description:(NSString *)description studio:(NSString *)studio photo:(NSString *)photo urlStr:(NSString *)urlStr;

+ (GCKUICastContainerViewController *)createCastContainerControllerForViewController:(UIViewController *)viewController;
@end
